Merge branch 'vendor/LIBRESSL'
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.4 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 GCC50 REMOVED
16 -------------
17
18 The GCC50 compiler has been retired.  It has been replaced by a GCC80.
19 The default alternative compiler has stayed the same - GCC47.
20
21
22 PUFFS, PUTTER AND LIBREFUSE REMOVED
23 -----------------------------------
24
25 The puffs(4)/putter(4) subsystem has been removed, along with librefuse,
26 libpuffs, and the mount_psshfs(8) utility. All of these have never been
27 working correctly.
28
29 FFS_ROOT OPTION REMOVED
30 -----------------------
31
32 The FFS_ROOT kernel configuration option has been finally removed, after
33 having been a no-op since 4.9. That means users using a custom kernel
34 configuration file that still contains it need to remove the option from
35 that file.
36
37 +-----------------------------------------------------------------------+
38 +         UPGRADING DRAGONFLY FROM 5.2 TO LATER VERSIONS                +
39 +-----------------------------------------------------------------------+
40
41 DIGI, RP AND SI DRIVERS REMOVED
42 -------------------------------
43
44 The digi(4), rp(4) and si(4) serial drivers have been removed. None of
45 them were in our default kernel configuration file. The sicontrol(8)
46 utility was removed, too.
47
48 MKINITRD COMMAND REMOVED
49 ------------------------
50
51 The mkinitrd(8) command is removed and its functionality is replaced by
52 the new "initrd" make target.  After rebooting into the new world and
53 verifying everything works, execute "make initrd" to upgrade the rescue
54 tools and initrd image.
55
56 IPSEC, IPSEC_ESP AND IPSEC_DEBUG REMOVED FROM VKERNEL64 CONFIG
57 --------------------------------------------------------------
58
59 IPsec has been removed from the system. Of our standard kernel
60 configurations, only the virtual kernel one had it. People running
61 vkernels with configuration files derived from our VKERNEL64 will
62 have to remove these options manually.
63
64 +-----------------------------------------------------------------------+
65 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
66 +-----------------------------------------------------------------------+
67
68 VIRTIO_PCI REMOVED FROM KERNEL CONFIG
69 -------------------------------------
70
71 The "device virtio_pci" line in X86_64_GENERIC has been removed. People
72 with configuration files derived from it have to remove it manually.
73
74 VARIOUS 'R' COMMANDS AND DAEMONS REMOVED
75 ----------------------------------------
76
77 rcp(1), rlogin(1), rlogind(8), rsh(1) and rshd(8) have been removed.
78 For those that still need them, there is the net/bsdrcmds port.
79
80 VARIOUS FORMER OPTIONS REMOVED
81 ------------------------------
82
83 Various former kernel configuration options which had been no-ops for
84 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
85 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
86 their kernel configuration files have to remove them.
87
88 BOOTSTRAPPING LIMITED FROM PRE 4.4
89 ----------------------------------
90
91 Upgrading to 5.1 and later versions now require at least 4.4 in
92 preparations for upcoming base compilers updates.
93
94 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
95 ------------------------------------------
96
97 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
98 already been removed from our default kernel configuration before 5.0,
99 so only people with custom configurations based on earlier X86_64_GENERIC
100 will have to remove it manually.
101
102 The faith(4) interface has been completely removed after it had also
103 been removed from our default kernel configuration. 
104
105 +-----------------------------------------------------------------------+
106 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
107 +-----------------------------------------------------------------------+
108
109 FFS_ROOT OPTION DISABLED
110 ------------------------
111
112 The FFS_ROOT option has been made a no-op and will be completely removed
113 at some point in the future. Users with a custom kernel configuration
114 can remove this option from it now.
115
116 +-----------------------------------------------------------------------+
117 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
118 +-----------------------------------------------------------------------+
119
120 DSA OPENSSH KEYS DEPRECATED
121 ---------------------------
122
123 Note that DSA OpenSSH keys were deprecated in the 4.6 to 4.8 release. 
124 If you are upgrading from a release older than 4.8 and use DSA OpenSSH 
125 keys, please update your private/public key pair or risk locking 
126 yourself out.
127
128 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
129 -----------------------------------------------
130
131 They were all in our X86_64_GENERIC kernel configuration file, along with
132 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
133 configuration files derived from it need adjustment.
134
135 PORTAL FILE SYSTEM REMOVED
136 --------------------------
137
138 It has been broken for a long time now.
139
140 BINUTILS 2.27 REPLACES 2.24, PRIMARY
141 ------------------------------------
142
143 The oldest of the two versions of Binutils, version 2.24, was removed
144 and replaced with Binutils 2.27.  It becomes the primary version version
145 of binutils and version 2.25 becomes the alternate.
146
147 The accepted values of BINUTILSVER are now "binutils227" (default) and
148 "binutils225".  The building of Binutils 2.25 can be prevented by setting
149 NO_ALTBINUTILS=yes in make.conf.
150
151 COMPAT_43 KERNEL OPTION REMOVED
152 -------------------------------
153
154 It was commented out in our default configs for several years now, but
155 might still be present in custom configs created before Nov. 2011.
156
157 OPENSSL REMOVED
158 ---------------
159
160 OpenSSL has been removed from base and replaced with a private version of
161 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
162 pages will remain on the system unless the "make upgrade" command is
163 specifically instructed to remove them.  To do this, define
164 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
165 "make upgrade REMOVE_OPENSSL_FILES=yes"
166
167 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
168 stale OpenSSL files be removed to avoid configuration scripts from using
169 the stale and potentially vulnerable version, but all binaries that are
170 dynamically linked to the OpenSSL libraries should be rebuilt first to
171 avoid breakage.
172
173 OPENSSH HPN REMOVED
174 -------------------
175
176 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
177 To use OpenSSH in base remove HPN config, if you have added it.
178 Check files below for HPN config, see a few lines below.
179   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
180 sshd(8) will fail to start if HPN config is used.
181
182 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
183
184 HPN config:
185 HPNDisabled
186 HPNBufferSize
187 TcpRcvBuf
188 TcpRcvBufPoll
189 NoneEnabled
190 NoneSwitch
191 cipher MTR-AES-CTR
192 cipher NONE
193
194 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
195 circumstances, especially for networking.
196 If HPN functionality is needed, install security/openssh from dports.
197
198 CS, EX AND VX DRIVERS REMOVED
199 -----------------------------
200
201 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
202 old and its doubtful they ever worked properly in x86_64 but they were
203 in X86_64_GENERIC, so custom configurations derived from it have to be
204 adjusted.
205
206 +-----------------------------------------------------------------------+
207 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
208 +-----------------------------------------------------------------------+
209
210 AMD REMOVED
211 -----------
212
213 The am-utils automounter suite has been removed. It stopped working
214 at some point and was never fixed. autofs(5) and the associated
215 userland has been brought in from FreeBSD and replaces it.
216
217 AN DRIVER REMOVED
218 -----------------
219
220 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
221 config file, so any configurations derived from it have to be adjusted.
222
223 /DEV/DRI GROUP CHANGED
224 ----------------------
225
226 The default group assigned to /dev/dri entries has been changed
227 from 'wheel' to 'video' with the id of '44'. If you want to have
228 access to the dri devices please add yourself to the video group
229 with:
230
231 # pw groupmod video -m $USER
232
233 +-----------------------------------------------------------------------+
234 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
235 +-----------------------------------------------------------------------+
236
237 DSCHED REMOVED
238 --------------
239
240 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
241 in our default kernel config file. So the DSCHED_FQ option has been turned
242 into a no-op for now and can be removed from custom configurations.
243
244 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
245 -------------------------------------------------
246
247 The est(4) driver has been removed. All CPUs it supported (except one)
248 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
249 report back if there are any issues with this CPU and our regular ACPI
250 P-state support.
251
252 Also, compile_et(1) and com_err(3) have been removed as well. They
253 should have been removed along with kerberos support, back in 2009.
254
255 SEVERAL LOCALES RENAMED
256 -----------------------
257
258 Several locales were using obsolete and misleading names, and thus have
259 been adjusted to current standards. Any users of the following locales
260 need to select alternates:
261
262 DFLY 4.2 locale            DFLY 4.4 alterative locale
263 ---------------            ------------------------------------
264 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
265 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
266 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
267 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
268 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
269 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
270 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
271 zh_CN.GBK                  zh_Hans_CN.GBK
272 zh_CN.UTF-8                zh_Hans_CN.UTF-8
273 zh_CN.eucCN                zh_Hans_CN.eucCN
274 zh_CN.GB2312               zh_Hans_CH.GB2312
275 zh_CN.GB18030              zh_Hans_CH.GB18030
276 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
277 zh_HK.UTF_8                zh_Hant_HK.UTF-8
278 zh_TW.Big5                 zh_Hant_TW.Big5
279 zh_TW.UTF-8                zh_Hant_TW.UTF-8
280
281 +-----------------------------------------------------------------------+
282 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
283 +-----------------------------------------------------------------------+
284
285 BINUTILS 2.25 REPLACES 2.22, PRIMARY
286 ------------------------------------
287
288 The oldest of the two versions of Binutils, version 2.22, was removed
289 and replaced with Binutils 2.25.  It becomes the primary version version
290 of binutils and version 2.24 becomes the alternate.  There are 8 current
291 CVE written against 2.24, so for security reasons version 2.25 should
292 always be used.
293
294 The accepted values of BINUTILSVER are now "binutils225" (default) and
295 "binutils224".  The building of Binutils 2.24 can be prevented by setting
296 NO_ALTBINUTILS=yes in make.conf.
297
298 LOADER OPTIONS CHANGED
299 ----------------------
300
301 Right after the development branch started, the Fred art accompanying the
302 loader menu was improved.  The line between Fred and the menu was removed
303 by default (but can optionally be returned) and the placement shifted as
304 a result.  The drawing was improved, and the colored version was improved,
305 changing the eyes and wing color from white to red.  A new color version
306 of Fred was added, one with a blue scheme.
307
308 The loader menu defaults have changed since release 4.0:  The vertical
309 line was removed, the loader is displayed in color by default*, and the
310 blue scheme is used.
311
312 The loader.conf changes are:
313 loader_color:   option has been removed
314 loader_plain:   option has been added, it changed menu to monochrome
315 fred_is_red:    changes color scheme from blue to red
316 fred_is_blue:   option existed only on 4.1, it has been removed
317 fred_separated: Adds line between Fred and menu (as seen previously)
318
319 * If loader.conf defines "console" as "comconsole" or "console" is defined
320   in the environment as "comconsole" then color will not be displayed,
321   even if loader_plain value is "NO".
322
323 SENDMAIL REMOVED FROM BASE
324 --------------------------
325
326 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
327 If the system being upgraded is still configured to use the sendmail
328 binaries from base, the "make upgrade" command will fail.
329
330 The administrator must change /etc/mail/mailer.conf to switch the
331 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
332 command that permanently removes sendmail executables and could
333 potentially break a running mail server.
334
335 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
336 detailed instructions on how to configure the MTA selection.
337
338 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
339 --------------------------------------------
340
341 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
342 no-ops. They can be removed from custom kernel configurations.
343
344 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
345 --------------------------------------------
346
347 Many more sound devices may be detected.
348
349 If the default device choosen isn't to your liking, setting the sysctl
350 hw.snd.default_unit to a different number will change it.
351
352 SCTP SUPPORT DROPPED
353 --------------------
354
355 Support for the SCTP protocol has been removed.
356
357 OLD USB DRIVERS REMOVED
358 -----------------------
359
360 The old USB stack, along with the kernel config option "device oldusb"
361 and the make.conf variable "WANT_OLDUSB" have been removed. This means
362 that for custom kernel configuration files which were derived from a
363 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
364 various (old USB stack specific) devices will now complain about being
365 unknown:
366
367   * oldusb      (obviously)
368   * natausb     (not yet ported to usb4bsd)
369   * rue         (not yet ported to usb4bsd)
370   * ugen        (no longer needed in usb4bsd)
371   * urio        (not yet ported to usb4bsd)
372   * uscanner    (no longer needed in usb4bsd)
373
374 They should be removed or commented out in such custom kernel configs.
375
376 GCC 5
377 -----
378
379 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
380 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
381 NO_CXX.  The latter was never documented and the latest versions of GCC are
382 partially written in C++ so a C++ compiler is no longer optional.  In
383 practical terms it has not been optional for many years as other base
384 components are also written in C++.  The resource savings by avoiding
385 building Objective-C compiler is so small, the complexity added by NO_OBJC
386 internally was deemed a bad tradeoff so that is the reason for its removal.
387 Also note that no "info" pages are installed with GCC 5.  After this entry
388 was originally written, all info pages were removed from DragonFly.
389
390 GCC 5.1 has been designated as the primary compiler.  As such, there is a
391 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
392 the designated secondary compiler, GCC 4.7.  However, while DPorts
393 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
394 if building ports from source is desired, don't block building of the
395 secondary compiler.
396
397 +-----------------------------------------------------------------------+
398 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
399 +-----------------------------------------------------------------------+
400
401 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
402 -------------------------------------------
403
404 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
405 the default now (even on single-core systems), both for, like, 21 months.
406 We kept the options around as no-ops as a convenience, to allow people
407 using the same config for the then current release and the then current
408 master. That period is now over, so any configs still having those
409 options have to be adjusted.
410
411 SYSVIPC SYSCALLS MADE NON-OPTIONAL
412 ----------------------------------
413
414 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
415 now compiled in by default. The options are no-ops for now.
416
417 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
418 --------------------------------------------------------------------
419
420 The default driver for those controllers is now mrsas(4) due to reports
421 of file system corruption using the mfi(4) driver. The whole issue (and
422 how to deal with potential problems when switching) was explained here:
423
424 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
425
426 A tunable is provided for letting those controllers still attach via
427 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
428
429 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
430 ----------------------------------------
431
432 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
433 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
434 removed in kernel configs derived from X86_64_GENERIC.
435
436 +-----------------------------------------------------------------------+
437 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
438 +-----------------------------------------------------------------------+
439
440 UPDATE FROM MOST RECENT 3.6
441 ---------------------------
442
443 Versions of 3.6 built before June 25th have a bug where installworld might 
444 crash during installation of the new initrd.  Upgrade to the latest version
445 of 3.6 before updating to 3.8 or later.
446
447 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
448 --------------------------------------
449
450 Support for the IPX and NCP network protocols and for mouting NetWare
451 file systems has been dropped. Dito for ATM protocol support.
452
453 INITRD IMAGES NOW INSTALLED BY DEFAULT
454 --------------------------------------
455
456 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
457
458 Older images installed under the file name of initrd.img will be removed
459 automatically by the make upgrade process.
460
461 USB4BSD IS NOW THE DEFAULT USB STACK
462 ------------------------------------
463
464 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
465 replace "device usb" with "device oldusb" in the kernel configuration.
466
467 MORE ISA SUPPORT DROPPED
468 ------------------------
469
470 ISA support has been dropped from the following drivers: adv(4), an(4),
471 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
472 si(4), sn(4), and stg(4).
473
474 +-----------------------------------------------------------------------+
475 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
476 +-----------------------------------------------------------------------+
477
478 ABI CHANGE
479 ----------
480
481 Installed third-party software (dports) will have to be rebuilt after upgrade,
482 or reinstalled from binary packages.
483
484 UPDATING FROM 3.4 TO 3.6
485 ------------------------
486
487 This only applies for this specific upgrade due to locale changes; it is 
488 not needed for upgrades after 3.6.  Please update in this order:
489
490 make buildworld
491 make buildkernel
492 make installworld
493 make installkernel
494 *reboot*
495 make upgrade
496
497 See this mailing list post for details:
498 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
499
500 CYRIX OPTIONS REMOVED
501 ---------------------
502
503 The following Cyrix related options have been removed: CPU_BTB_EN,
504 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
505 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
506 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
507
508 ISA SUPPORT REMOVED FROM RP(4)
509 ------------------------------
510
511 ISA support has been removed from the rp(4) driver. It is now PCI only.
512
513 +-----------------------------------------------------------------------+
514 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
515 +-----------------------------------------------------------------------+
516
517 COMPAT_SUNOS OPTION REMOVED
518 ---------------------------
519
520 The COMPAT_SUNOS option has been removed. It was meant to provide binary
521 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
522
523 ISA SOUND CARD SUPPORT REMOVED
524 ------------------------------
525
526 The following modules have been removed (all for ISA sound cards):
527 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
528
529 GCC 4.7
530 -------
531
532 DragonFly has switched base compilers.  GCC 4.7 is now the default
533 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
534 variable ceases to work now.
535
536 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
537 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
538 highly discouraged.  There are a few packages in pkgsrc that do not build
539 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
540 this time, it is recommended to keep both compilers on the base system.
541
542 SMP OPTION REMOVED
543 ------------------
544
545 The SMP kernel option has been made a no-op. All kernels now feature SMP
546 support. If you have 'options SMP' in your kernel config, you can as well
547 remove it.
548
549 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
550 ---------------------------------------------------------------------------
551
552 The DEVICE_POLLING kernel option has been made a no-op and it has been
553 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
554 kernel config, you need to change it to IFPOLL_ENABLE.
555
556 Also, the KTR_POLLING kernel option has been removed, so it must be
557 removed from kernel configs that have it.
558
559 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
560 ---------------------------------------------------
561
562 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
563 cards will no longer be detected.
564
565 The same has been done for Stallion multiport serial controllers. stli(4)
566 has been completely removed (along with the stlload(8) and stlstty(8)
567 utilities) and stl(4) was changed to support only PCI cards. Similarly,
568 ISA support was removed from cy(4) too. All these drivers are i386 only.
569
570 COMPAT_OLDISA OPTION GONE
571 -------------------------
572
573 The i386 specific COMPAT_OLDISA kernel option has been removed, since
574 nothing needs it anymore.
575
576 +-----------------------------------------------------------------------+
577 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
578 +-----------------------------------------------------------------------+
579
580 APIC_IO OPTION REMOVED
581 ----------------------
582
583 The APIC_IO kernel option is no longer accepted after having been without
584 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
585 If you have 'options APIC_IO' in your kernel config, you'll have to
586 remove it.
587
588 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
589 -----------------------------------------
590
591 The wdog framework is now compiled into our kernels by default, so the
592 options are no longer needed.
593
594 DOSCMD(1) REMOVED
595 -----------------
596
597 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
598 NO_X make.conf option was removed too.
599
600 GCC 4.7
601 -------
602
603 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
604 default compiler in base (default is still GCC 4.4).
605
606 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
607 NO_GCC47 in /etc/make.conf.
608
609 USB4BSD
610 -------
611
612 A new USB stack (from FreeBSD) has been brought in. The following
613 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
614 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
615 and uaudio.
616
617 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
618 be put in make.conf and device "usb4bsd" (quotes needed) has to
619 replace device usb in the kernel config. After that, a full
620 build/install/upgrade cycle is needed.
621
622 Note that this is experimental and incomplete, but we are interested
623 in hearing about issues with it, of course.
624
625 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
626 ---------------------------------------------
627
628 ISA adapter support was dropped from the aic(4) driver.
629
630 +-----------------------------------------------------------------------+
631 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
632 +-----------------------------------------------------------------------+
633
634 SEVERAL ISA DRIVERS REMOVED
635 ---------------------------
636
637 The following ISA only drivers have been removed along with a couple of
638 associated userland tools:
639
640 aha(4)
641 asc(4) & sasc(1)
642 ctx
643 dgb(4)
644 el(4)
645 gpib
646 gsc(4) & sgsc(1)
647 ie(4)
648 labpc(4)
649 le(4)
650 mse(4)
651 rc(4)
652 rdp(4)
653 spigot
654 tw(4) & xten(1) & xtend(8)
655 wl(4) & wlconfig(8)
656 wt(4)
657
658 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
659 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
660 file.
661
662 If buildkernel complains about any of these drivers, just remove them
663 from your kernel configuration.
664
665 BINUTILS 2.20
666 -------------
667 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
668 values of BINUTILSVERS are now binutils221 and binutils222 (default).
669
670 BUILDWORLD/-KERNEL PARALLELIZATION WORK
671 ---------------------------------------
672 Due to changes in the way we build with more than one make job, you
673 will have to update install(1) and mkdir(1) prior to buildworld if you
674 want to build with 'make -j':
675
676 cd /usr/src/usr.bin/xinstall; make; make install; make clean
677 cd /usr/src/bin/mkdir; make; make install; make clean
678
679 DMA(8) UPGRADE
680 --------------
681 dma(8) has been upgraded to v0.7 which no longer supports the
682 /etc/dma/virtusertable. Some of its functionality has been replaced
683 with the MASQUERADE keyword and the EMAIL environment variable (see
684 the dma(8) manual page).
685
686 +-----------------------------------------------------------------------+
687 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
688 +-----------------------------------------------------------------------+
689
690 GCC 4.4 & BINUTILS 2.21
691 -----------------------
692
693 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
694 been made DragonFly's default Binutils.
695
696 That means that any settings that set CCVER to 'gcc44' are not needed
697 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
698 GCC 4.1.
699
700 It also means that 'binutils221' as a value for BINUTILSVER has no
701 effect anymore. 2.17 has been removed and 'binutils220' is available
702 as an option.
703
704 The NO_GCC44 option has been removed and will not affect the build
705 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
706 building in a similar fashion.
707
708 Note that you must do a full buildworld/buildkernel for upgrading.
709
710 pkg_radd settings
711 -----------------
712
713 The config file for pkg_radd has moved from /etc/settings.conf to 
714 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
715 if this is needed.  This warning only applies if /etc/settings.conf 
716 exists.  pkg_radd will continue to work with defaults.
717
718 +-----------------------------------------------------------------------+
719 +         20100927                                                      +
720 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
721 +-----------------------------------------------------------------------+
722
723 OpenSSL
724 --------
725
726 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
727 This shouldn't break any 3rd-party software, but you'll need to recompile your
728 3rd-party software if you want it to link against the new version of OpenSSL.
729
730 Loader
731 -------
732
733 A new loader (dloader) has been added which better handles booting from
734 multiple kernel/module versions.
735
736 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
737
738         cd /usr/src
739         make buildworld
740         make installworld
741         make upgrade
742         make buildkernel KERNCONF=<KERNELNAME>
743         make installkernel KERNCONF=<KERNELNAME>
744
745 Note that you must installworld and run the 'upgrade' target before
746 installing the new kernel.
747
748 BIND
749 -----
750
751 BIND has been removed from the base system.  The ldns and drill tools have 
752 been added for basic functionality.  Use 'drill' where you would normally 
753 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
754 net/bind95, net/bind96, or net/bind97 as of this writing.
755
756 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
757 include BIND as a pkgsrc package.
758
759 +-----------------------------------------------------------------------+
760 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
761 +                               GENERAL                                 +
762 +-----------------------------------------------------------------------+
763
764 Instructions on how to obtain and maintain DragonFly source code using git
765 are in the development(7) manual page.
766
767 To upgrade a DragonFly system from sources you run the following sequence:
768
769         cd /usr/src
770         make buildworld
771         make buildkernel KERNCONF=<KERNELNAME>
772         make installkernel KERNCONF=<KERNELNAME>
773         make installworld
774
775 You will also want to run the 'upgrade' target to upgrade your /etc and the
776 rest of your system.  The upgrade target is aware of stale files created by
777 older DragonFly installations and should delete them automatically.
778
779         make upgrade
780
781 See the build(7) manual page for further information.
782
783 Once you've done a full build of the world and kernel you can do incremental
784 upgrades of either by using the 'quickworld' and 'quickkernel' targets
785 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
786 the quick targets, try updating your repo first, and then a full buildworld
787 and buildkernel as shown above, before asking for help.
788
789 +-----------------------------------------------------------------------+
790 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
791 +-----------------------------------------------------------------------+
792
793 In 2.1 kernel and modules has moved to boot directory.  For most cases
794 this is handled automatically by 'make upgrade'.  A few cases needs manual
795 intervention:
796
797  * When installing a kernel without first doing a make buildworld,
798    installworld and upgrade to the same DESTDIR as kernel:
799    make DESTDIR/boot directory and move kernel and modules into this boot
800    directory; also move kernel.old and modules.old.
801    Typical example is vkernel(7), use (no modules used):
802
803         cd /var/vkernel
804         mkdir boot
805         chflags noschg kernel
806         mv kernel kernel.old boot
807         chflags schg boot/kernel
808         
809  * When using a boot-only partition, /boot/loader.rc needs to be edited:
810    delete occurrences of '/boot/'.
811    These occurences can normally be deleted in any case, see loader(8).
812
813 +-----------------------------------------------------------------------+
814 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
815 +-----------------------------------------------------------------------+
816
817 In 1.9 major changes to the disk management infrastructure have taken
818 place.  make upgrade may not catch all of your disk devices in /dev,
819 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
820 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
821 and MAKEDEV no longer exists.
822
823 The biggest changes in 1.9 are:
824
825 (1) That whole-slice devices such as da0s1 no longer share the same device
826     id as partition c devices such as da0s1c.
827
828 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
829     with no snooping or reserved sectors.  Consequently you cannot run
830     disklabel on this device.  Instead you must run disklabel on a
831     whole-slice device.
832
833 (3) The 'compatibility' partitions now use slice 0 in the device name,
834     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
835     accessing the disklabel for the compatibility partitions must be
836     done via slice 0 (da0s0).
837
838 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
839     and CCD now run through the disk management layer and are assigned
840     real disk management devices.   VN and CCD in particular do not usually
841     use a MBR and disklabels must be accessed through the compatibility
842     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
843     don't name it 'ccd0s0' in the config file.
844
845 Generally speaking, you have to get used to running fdisk and disklabel on
846 the correctly specified device names.  A lot of the wiggle, such as running
847 disklabel on a partition, has been removed.
848
849 +-----------------------------------------------------------------------+
850 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
851 +-----------------------------------------------------------------------+
852
853 > Kerberos IV
854 -------------
855
856 Kerberos IV (eBones) was removed from the tree, please consider moving to
857 Kerberos 5 (Heimdal).
858
859 > Package Management System
860 ---------------------------
861
862 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
863 management system.  The necessary tools to build and maintain packages
864 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
865 directories are in your PATH variable.
866
867 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
868 the tarball from NetBSD:
869
870         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
871         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
872
873 This tree can then be kept up to date with cvs update:
874
875         cd /usr/pkgsrc; cvs up
876
877 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
878 build and install the pkgsrc bootstrap manually:
879
880         cd /usr/pkgsrc/bootstrap
881         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
882
883 +-----------------------------------------------------------------------+
884 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
885 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
886 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
887 +-----------------------------------------------------------------------+
888
889 The compatibility shims for the build environment have been removed, you
890 have to update to DragonFly 1.2 release branch first.
891
892 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
893 The existing configuration can be converted using /etc/pam.d/convert.sh.
894 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
895 the pam_skey.so module was retired, you have to remove it manually from
896 your configuration, when you convert it.
897
898 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
899 ---------------------
900
901 The following users may be missing from your password file.  Use vipw and
902 add any that are missing:
903
904 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
905 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
906
907 The following groups may be missing from your group file.  Use vi /etc/group
908 and add any that are missing:
909
910 smmsp:*:25:
911 authpf:*:63:
912 _pflogd:*:64:
913
914
915 > Upgrading to DragonFly from FreeBSD
916 ---------------------
917
918 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
919 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
920 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
921 make depend information, it starts from scratch, so no pre-cleaning of the
922 object hierarchy is necessary.
923
924         # get the CVS repository (it is placed in /home/dcvs, 500MB).
925         # Please use the -h option and a mirror site to pull the 
926         # initial repository, but feel free to use the main repository
927         # machine to pull updates.
928         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
929         # install the source from the CVS hierarchy (remove preexisting
930         # FreeBSD src first) (500MB)
931         cd /usr
932         rm -rf src
933         cvs -R -d /home/dcvs checkout -P src
934
935         # build it (500MB used in /usr/obj)
936         #
937         cd /usr/src
938         make buildworld
939         make buildkernel KERNCONF=<KERNELNAME>
940
941 Once you have built DragonFly you have to install it over FreeBSD.  Since
942 DragonFly does not track changes made by FreeBSD to its include file 
943 hierarchy and include file pollution can cause all sorts of unexpected
944 compilation issues to come up, it is best to wipe your include hierarchy
945 prior to installing DragonFly.  Note that you should not wipe any installed
946 FreeBSD header files or binaries until after you have successfully completed
947 the build steps above.
948
949         rm -rf /usr/include
950         mkdir /usr/include
951         make installkernel KERNCONF=<KERNELNAME>
952         make installworld
953
954 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
955 will unconditionally upgrade the /etc files that sysops do not usually
956 mess around with, such as the files in /etc/rc.d.  It will also remove any
957 obsolete files such as utilities and manpages that have been removed from
958 the system since the version you're coming from.  If you are unsure we 
959 recommend that you make a backup of at least your /etc before applying
960 this step.  Note that DragonFly's RC system is basically RCNG from
961 FreeBSD-5, but there are some differences in the contents of the RC files.
962
963         make upgrade
964
965 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
966 Doing so might leave your system in an unusable state.
967
968 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
969 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
970 report these files to the DragonFly developers so that they can be added to
971 the 'upgrade' target.
972